﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Grafika {
    public partial class Form1 : Form {
        public Form1() {
            InitializeComponent();

        }

        bool first = true;
        int X;
        int Y;
        int layer = 1;

        //                color, s,    p,     floor
        static List<Tuple<Color, Size, Point, int>> pieces = new List<Tuple<Color, Size, Point, int>>();

        private void panel1_Paint(object sender, PaintEventArgs e) {
            Graphics gr = e.Graphics;
            if (first) {

            } else {
                int sizeX = (panel1.Width - 40) / X;
                int sizeY = (panel1.Height - 40) / Y;
                int size = 0;
                if (sizeX < sizeY) {
                    size = sizeX;
                } else {
                    size = sizeY;
                }

                foreach (Tuple<Color, Size, Point, int> t in pieces) {
                    if (t.Item4 == layer) {
                        gr.FillRectangle(
                            new SolidBrush(t.Item1),
                            (t.Item3.X - 1) * size + 20,
                            (t.Item3.Y - 1) * size + 20,
                            size * t.Item2.Width,
                            size * t.Item2.Height
                        );

                        gr.DrawRectangle(
                            new Pen(Color.Black, 1),
                            (t.Item3.X - 1) * size + 20,
                            (t.Item3.Y - 1) * size + 20,
                            size * t.Item2.Width,
                            size * t.Item2.Height
                        );
                    }
                }


            }
            first = false;
        }

        private void openToolStripButton_Click(object sender, EventArgs e) {
            openFileDialog1.ShowDialog();
            FileStream st = new FileStream(openFileDialog1.FileName, FileMode.Open, FileAccess.Read);
            using (StreamReader sr = new StreamReader(st)) {
                List<string> parts = Separate(sr.ReadLine());
                Int32.TryParse(parts[0], out X);
                Int32.TryParse(parts[1], out Y);
                while (!sr.EndOfStream) {
                    string str = sr.ReadLine();
                    if (str != "") {
                        parts = Separate(str);
                        Color c;
                        Point p;
                        Size s;
                        int Xp;
                        int Yp;
                        int Xs;
                        int Ys;
                        int Count;
                        int Floor;
                        switch (parts[3]) {
                            case "A":
                                c = Color.FromArgb(0, 255, 255);
                                break;
                            case "R":
                                c = Color.FromArgb(255, 0, 0);
                                break;
                            case "G":
                                c = Color.FromArgb(0, 255, 0);
                                break;
                            case "B":
                                c = Color.FromArgb(0, 0, 255);
                                break;
                            case "Y":
                                c = Color.FromArgb(255, 255, 0);
                                break;
                            default:
                                c = Color.FromArgb(100, 100, 100);
                                break;
                        }
                        List<string> splited = parts[4].ToUpper().Split('X').ToList();
                        Int32.TryParse(parts[0], out Floor);
                        Int32.TryParse(parts[1], out Xp);
                        Int32.TryParse(parts[2], out Yp);
                        Int32.TryParse(splited[0], out Xs);
                        Int32.TryParse(splited[1], out Ys);
                        p = new Point(Xp, Yp);
                        s = new Size(Xs, Ys);
                        Int32.TryParse(parts[2], out Count);
                        pieces.Add(new Tuple<Color, Size, Point, int>(c, s, p, Floor));
                    }
                }
            }
            panel1.Invalidate();
        }

        private List<string> Separate(string str) {
            List<string> splited = str.Split(' ').ToList();
            while (splited.Contains("")) {
                splited.Remove("");
            }
            return splited;
        }

        private void panel1_SizeChanged(object sender, EventArgs e) {
            panel1.Invalidate();
        }

        private void toolStripButton2_Click(object sender, EventArgs e) {
            if (layer > 1) {
                layer--;
            }
            panel1.Invalidate();
        }

        private void toolStripButton1_Click(object sender, EventArgs e) {
            layer++;
            panel1.Invalidate();
        }

    }
}
