﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Plan {

    class Program {

        static int X;
        static int Y;
        static string type;

        //                R,   G,   B,   sX,  sY,  Count  
        static List<Tuple<int, int, int, int, int, int>> pieces = new List<Tuple<int, int, int, int, int, int>>();

        //                     Color,  sX,  sY,  pX,  pY,  Floor  
        static List<List<Tuple<string, int, int, int, int, int>>> Floors = new List<List<Tuple<string, int, int, int, int, int>>>();

        static void Main(string[] args) {

            string directory = "";
            //directory = "C:/Z04/vzorova-data/vzorova_zadani";
            Console.Write("Zadejte adresu: ");
            directory = Console.ReadLine();
            string path = directory;
            DirectoryInfo d = new DirectoryInfo(directory);
            FileInfo[] Files = d.GetFiles("*.in");
            foreach (FileInfo file in Files) {
                path = directory + @"\" + file.Name;

                #region Parsing
                FileStream s = new FileStream(path, FileMode.Open, FileAccess.Read);
                using (StreamReader sr = new StreamReader(s)) {
                    List<string> parts = Separate(sr.ReadLine());
                    Int32.TryParse(parts[0], out X);
                    Int32.TryParse(parts[1], out Y);
                    type = parts[2];
                    while (!sr.EndOfStream) {
                        parts = Separate(sr.ReadLine());
                        int Rp;
                        int Gp;
                        int Bp;
                        int Xp;
                        int Yp;
                        int Count;
                        switch (parts[0]) {
                            case "A":
                                Rp = 0;
                                Gp = 255;
                                Bp = 255;
                                break;
                            case "R":
                                Rp = 255;
                                Gp = 0;
                                Bp = 0;
                                break;
                            case "G":
                                Rp = 0;
                                Gp = 255;
                                Bp = 0;
                                break;
                            case "B":
                                Rp = 0;
                                Gp = 0;
                                Bp = 255;
                                break;
                            case "Y":
                                Rp = 255;
                                Gp = 255;
                                Bp = 0;
                                break;
                            default:
                                return;
                        }
                        List<string> splited = parts[1].ToUpper().Split('X').ToList();
                        Int32.TryParse(splited[0], out Xp);
                        Int32.TryParse(splited[1], out Yp);
                        Int32.TryParse(parts[2], out Count);
                        pieces.Add(new Tuple<int, int, int, int, int, int>(Rp, Gp, Bp, Xp, Yp, Count));
                    }
                }
            #endregion

                #region Counting
                bool error = false;
                int Xa = 0;
                int Ya = 0;
                Floors.Add(new List<Tuple<string, int, int, int, int, int>>());
                bool[,] used = new bool[X, Y];
                bool first = true;

                while (!error) {
                    while (used[Xa, Ya]) {
                        if (Xa < X - 1) {
                            Xa++;
                        } else {
                            Xa = 0;
                            if (Ya < Y - 1) {
                                Ya++;
                            } else {
                                used = new bool[X, Y];
                                Floors.Add(new List<Tuple<string, int, int, int, int, int>>());
                                Xa = 0;
                                Ya = 0;
                            }

                        }
                    }
                    if ((!(Xa == 0 && Xa == X - 1 && Ya == 0 && Ya == Y - 1)) || type.ToUpper() == "P" || type.ToUpper() == "PB" || first) {
                        switch (X - Xa) {
                            case 1:
                                switch (Y - Ya) {
                                    case 1:
                                        if (pieces.Any(c => (c.Item4 == 1) && (c.Item5 == 1) && (c.Item6 > 0))) {
                                            int id = Divide(1, 1);
                                            Floors.Last().Add(new Tuple<string, int, int, int, int, int>(pieces[id].Item1.ToString("X2") + pieces[id].Item2.ToString("X2") + pieces[id].Item3.ToString("X2"), 1, 1, Xa, Ya, Floors.Count()));
                                            used[Xa, Ya] = true;
                                            
                                        } else {
                                            Floors.RemoveAt(Floors.Count - 1);
                                            error = true;
                                        }
                                        break;
                                    case 2:
                                        if (pieces.Any(c => (c.Item4 == 1) && (c.Item5 == 2) && (c.Item6 > 0))) {
                                            int id = Divide(1, 2);
                                            Floors.Last().Add(new Tuple<string, int, int, int, int, int>(pieces[id].Item1.ToString("X2") + pieces[id].Item2.ToString("X2") + pieces[id].Item3.ToString("X2"), 1, 2, Xa, Ya, Floors.Count()));
                                            used[Xa, Ya] = true;
                                            used[Xa, Ya + 1] = true;
                                        } else {
                                            goto case 1;
                                        }
                                        break;
                                    case 3:
                                        if (pieces.Any(c => (c.Item4 == 1) && (c.Item5 == 3) && (c.Item6 > 0))) {
                                            int id = Divide(1, 3);
                                            Floors.Last().Add(new Tuple<string, int, int, int, int, int>(pieces[id].Item1.ToString("X2") + pieces[id].Item2.ToString("X2") + pieces[id].Item3.ToString("X2"), 1, 3, Xa, Ya, Floors.Count()));
                                            used[Xa, Ya] = true;
                                            used[Xa, Ya + 1] = true;
                                            used[Xa, Ya + 2] = true;
                                        } else {
                                            goto case 2;
                                        }
                                        break;
                                    default:
                                        if (pieces.Any(c => (c.Item4 == 1) && (c.Item5 == 4) && (c.Item6 > 0))) {
                                            int id = Divide(1, 4);
                                            Floors.Last().Add(new Tuple<string, int, int, int, int, int>(pieces[id].Item1.ToString("X2") + pieces[id].Item2.ToString("X2") + pieces[id].Item3.ToString("X2"), 1, 4, Xa, Ya, Floors.Count()));
                                            used[Xa, Ya] = true;
                                            used[Xa, Ya + 1] = true;
                                            used[Xa, Ya + 2] = true;
                                            used[Xa, Ya + 3] = true;
                                        } else {
                                            goto case 3;
                                        }
                                        break;
                                }
                                break;
                            case 2:
                                if ((Y - Ya == 1) && (pieces.Any(c => (c.Item4 == 1) && (c.Item5 == 2) && (c.Item6 > 0)))) {
                                    int id = Divide(1, 2);
                                    Floors.Last().Add(new Tuple<string, int, int, int, int, int>(pieces[id].Item1.ToString("X2") + pieces[id].Item2.ToString("X2") + pieces[id].Item3.ToString("X2"), 2, 1, Xa, Ya, Floors.Count()));
                                    used[Xa, Ya] = true;
                                    used[Xa + 1, Ya] = true;
                                } else {
                                    if (Xa < X - 2 && Ya < Y - 2){
                                        if ((pieces.Any(c => (c.Item4 == 2) && (c.Item5 == 2) && (c.Item6 > 0))) && used[Xa + 1, Ya] == false && used[Xa, Ya + 1] == false && used[Xa + 1, Ya + 1] == false) {
                                            int id = Divide(2, 2);
                                            Floors.Last().Add(new Tuple<string, int, int, int, int, int>(pieces[id].Item1.ToString("X2") + pieces[id].Item2.ToString("X2") + pieces[id].Item3.ToString("X2"), 2, 2, Xa, Ya, Floors.Count()));
                                            used[Xa, Ya] = true;
                                            used[Xa + 1, Ya] = true;
                                            used[Xa, Ya + 1] = true;
                                            used[Xa + 1, Ya + 1] = true;
                                        } else {
                                            goto case 1;
                                        }
                                    } else {
                                        goto case 1;
                                    }
                                }
                                break;
                            case 3:
                                if (pieces.Any(c => (c.Item4 == 1) && (c.Item5 == 3) && (c.Item6 > 0))) {
                                    int id = Divide(1, 3);
                                    Floors.Last().Add(new Tuple<string, int, int, int, int, int>(pieces[id].Item1.ToString("X2") + pieces[id].Item2.ToString("X2") + pieces[id].Item3.ToString("X2"), 3, 1, Xa, Ya, Floors.Count()));
                                    used[Xa, Ya] = true;
                                    used[Xa + 1, Ya] = true;
                                    used[Xa + 2, Ya] = true;
                                } else {
                                    goto case 2;
                                }
                                break;
                            default:
                                if (pieces.Any(c => (c.Item4 == 1) && (c.Item5 == 4) && (c.Item6 > 0))) {
                                    int id = Divide(1, 4);
                                    Floors.Last().Add(new Tuple<string, int, int, int, int, int>(pieces[id].Item1.ToString("X2") + pieces[id].Item2.ToString("X2") + pieces[id].Item3.ToString("X2"), 4, 1, Xa, Ya, Floors.Count()));
                                    used[Xa, Ya] = true;
                                    used[Xa + 1, Ya] = true;
                                    used[Xa + 2, Ya] = true;
                                    used[Xa + 3, Ya] = true;
                                } else {
                                    goto case 3;
                                }
                                break;
                        }
                        first = false;
                    }
                }
                #endregion

                #region Saving
                List<string> content = new List<string>();
                content.Add(X + " " + Y + " " + type);
                if (type.ToUpper() == "D" || type.ToUpper() == "DB") {
                    Floors.Reverse();
                }
                foreach (List<Tuple<string, int, int, int, int, int>> l in Floors) {
                    foreach (Tuple<string, int, int, int, int, int> t in l) {
                        string str = "";
                        switch (t.Item1) {
                            case "00FFFF":
                                str = "A";
                                break;
                            case "FF0000":
                                str = "R";
                                break;
                            case "00FF00":
                                str = "G";
                                break;
                            case "0000FF":
                                str = "B";
                                break;
                            case "FFFF00":
                                str = "Y";
                                break;
                            default:
                                str = "0";
                                break;
                        }
                        content.Add(t.Item6 + " " + (t.Item4+1) + " " + (t.Item5+1) + " " + str + " " + t.Item2 + "X" + t.Item3);
                    }
                    content.Add("");
                }
                File.WriteAllLines(path.Replace(".in", ".04"), content);
                #endregion
            }
        }

        static List<string> Separate(string str) {
            List<string> splited = str.Split(' ').ToList();
            while (splited.Contains("")) {
                splited.Remove("");
            }
            return splited;
        }

        static int Divide(int X, int Y) {
            int id = pieces.FindIndex(c => (c.Item4 == X) && (c.Item5 == Y) && (c.Item6 > 0));
            pieces[id] = new Tuple<int, int, int, int, int, int>(pieces[id].Item1, pieces[id].Item2, pieces[id].Item3, pieces[id].Item4, pieces[id].Item5, pieces[id].Item6 - 1);
            return id;
        }
    }
}
